Summary: Simple mail user agent
Name: bsd-mailx
Version: 8.1.2
Release: 5%{?dist}
License: BSD
Group: Applications/Internet
URL: http://www.openbsd.org/
# bsd-mailx's upstream provides only the CVS method of downloading source code.
# Use get-upstream-tarball.sh script to download the current version of bsd-mailx.
Source0: %{name}-%{version}.tar.xz
Source1: get-upstream-tarball.sh
Source2: copyright

# Adopted Debian patches
Patch0:  00-Makefiles.patch
Patch1:  01-Fix-includes.patch
Patch2:  02-Base-fixes-1.patch
Patch3:  03-Base-fixes-2.patch
Patch4:  04-Add-custom-header.patch
Patch5:  05-Mailx-fixes.patch
Patch6:  06-Use-lockf-instead-of-flock.patch
Patch7:  07-Initialize-head-struct.patch
# Skipped Debian's 08 patch
Patch9:  09-Saved-mbox-message.patch
Patch10: 10-Reply-To-header.patch
Patch11: 11-Showname-option.patch
Patch12: 12-REPLYTO-can-be-set-in-.mailrc-too.patch
Patch13: 13-Mailx-concatenates-messages.patch
Patch14: 14-Truncate-mailbox-instead-of-deleting-it.patch
Patch15: 15-No-space-left-in-tmp.patch
Patch16: 16-Stdin-not-a-tty.patch
Patch17: 17-Intialize-tv_used.patch
Patch18: 18-Wait-for-sendmail.patch
Patch19: 19-Fix-compilation-on-Hurd.patch
Patch20: 20-Don-t-delete-temporary-file.patch
Patch21: 21-Use-wordexpr-instead-of-echo.patch
Patch22: 22-Replace-newlines-with-spaces.patch
Patch23: 23-Treat-new-line-only-messages-as-empty-ones.patch
Patch24: 24-False-cant-send-email-errors.patch

# Our patches
Patch50: bsd-mailx-8.1.2-bsd-mail.patch

# CVE-2004-2771 CVE-2014-7844
Patch51: mailx-12.5-outof-Introduce-expandaddr-flag.patch
Patch52: mailx-12.5-fio.c-Unconditionally-require-wordexp-support.patch

Conflicts: mailx < 12.4-7

BuildRequires: libbsd-devel
Requires(post): %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives
Requires(postun): %{_sbindir}/alternatives

%description
The bsd-mailx package installs the /bin/mail program, which is used to
send quick email messages (i.e., without opening up a full-featured
mail user agent). Mail is often used in shell scripts.

%prep
%setup -q

%patch0  -p1 -b .makef
%patch1  -p1 -b .includes
%patch2  -p1 -b .base1
%patch3  -p1 -b .base2
%patch4  -p1 -b .custom-header
%patch5  -p1 -b .more-fixes
%patch6  -p1 -b .lockf
%patch7  -p1 -b .init-head
%patch9  -p1 -b .mbox-msg
%patch10 -p1 -b .reply-to
%patch11 -p1 -b .showname
%patch12 -p1 -b .reply-to-mailrc
%patch13 -p1 -b .concat-msgs
%patch14 -p1 -b .truncate-mbox
%patch15 -p1 -b .no-space-tmp
%patch16 -p1 -b .tty
%patch17 -p1 -b .tv-used
%patch18 -p1 -b .sendmail
%patch19 -p1 -b .hurd
%patch20 -p1 -b .temp-file
%patch21 -p1 -b .wordexpr
%patch22 -p1 -b .spaces
%patch23 -p1 -b .empty-msg
%patch24 -p1 -b .false-errors

%patch50 -p1 -b .bsd-mail
%patch51 -p1
%patch52 -p1

%{__cp} %{SOURCE2} .

%build
export CFLAGS="$RPM_OPT_FLAGS -D_PATH_PAGER=\\\"%{_bindir}/less\\\""
make %{?_smp_mflags}

%install
mkdir -p ${RPM_BUILD_ROOT}/{bin,etc}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1

make DESTDIR=${RPM_BUILD_ROOT} install

mv ${RPM_BUILD_ROOT}%{_sysconfdir}/mail.rc ${RPM_BUILD_ROOT}%{_sysconfdir}/bsd-mail.rc
# touch ghost files
touch ${RPM_BUILD_ROOT}/bin/mail ${RPM_BUILD_ROOT}%{_bindir}/Mail \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/mail.1 ${RPM_BUILD_ROOT}%{_mandir}/man1/Mail.1

%postun
if [ $1 -ge 1 ] ; then
    mail=$(readlink %{_sysconfdir}/alternatives/mail)
    if [ "$mail" == "%{_bindir}/bsd-mailx" ]; then
        %{_sbindir}/alternatives --set mail %{_bindir}/bsd-mailx
    fi
fi
exit 0

%post
# Set up the alternative files for mail.
%{_sbindir}/alternatives --install /bin/mail mail %{_bindir}/bsd-mailx 30 \
    --slave %{_bindir}/Mail mail-Mail %{_bindir}/bsd-mailx \
    --slave %{_mandir}/man1/mail.1.gz mail-mail-man %{_mandir}/man1/bsd-mailx.1.gz \
    --slave %{_mandir}/man1/Mail.1.gz mail-Mail-man %{_mandir}/man1/bsd-mailx.1.gz

%preun
if [ $1 = 0 ]; then
    %{_sbindir}/alternatives --remove mail %{_bindir}/bsd-mailx
fi
exit 0

%files
%doc copyright
%config(noreplace) %{_sysconfdir}/bsd-mail.rc
%{_bindir}/bsd-mailx
%{_datadir}/bsd-mailx/mail.help
%{_datadir}/bsd-mailx/mail.tildehelp
%{_mandir}/man1/bsd-mailx.1*

%ghost %attr(0755,-,-) /bin/mail
%ghost %attr(0755,-,-) %{_bindir}/Mail
%ghost %{_mandir}/man1/mail.1*
%ghost %{_mandir}/man1/Mail.1*

%changelog
* Thu Dec 18 2014 jchaloup <jchaloup@redhat.com> - 8.1.2-5
- CVE-2004-2771 CVE-2014-7844 bsd-mailx: mailx: command execution flaw
  resolves: #1162783, #1174904

* Tue Jun 25 2013 Peter Schiffer <pschiffe@redhat.com> - 8.1.2-4
- added license file

* Mon Jun 24 2013 Peter Schiffer <pschiffe@redhat.com> - 8.1.2-3
- removed clean section

* Fri Jun 21 2013 Peter Schiffer <pschiffe@redhat.com> - 8.1.2-2
- removed buildroot tag

* Thu Jun 20 2013 Peter Schiffer <pschiffe@redhat.com> - 8.1.2-1
- initial package

