#!/bin/sh
#
# bsd-mailx's upstream provides only the CVS method of downloading source code.
# This script can be used for downloading the CVS repository and creating
# the tarball.
#
# Usage:  ./get-upstream-tarball.sh
#
# This code is in the public domain; do with it what you wish.
#
# Copyright (C) 2013 Peter Schiffer <pschiffe@redhat.com>
#

newdir=new-upstream-tarball

mkdir $newdir
cd $newdir

# checkout cvs
cvs -d anoncvs@anoncvs.ca.openbsd.org:/cvs get src/usr.bin/mail

# remove CVS folders
rm -rf src/usr.bin/mail/CVS src/usr.bin/mail/misc/CVS src/usr.bin/mail/USD.doc/CVS

# find version in src/usr.bin/mail/version.c file defined as:
# const char version[] = "xxx _date_";
ver=$(sed -rn 's/.*version\[\]\s+=\s+\"([0-9.]+).*/\1/p' src/usr.bin/mail/version.c)

mv src/usr.bin/mail bsd-mailx-$ver
tar cJf bsd-mailx-$ver.tar.xz bsd-mailx-$ver

rm -rf bsd-mailx-$ver src

